function scores = MOcluster_fitness(x, numEdges, Neighbor, numberofVariables, numNegEdges)
%function scores = cluster_fitness(x)
%CLUSTER_FITNESS  Custom fitness function for cluster. 
%   SCORES = CLUSTER_FITNESS(X,submatrix) Calculate the fitness 
%   of an individual. The fitness is the sum of the scores of each cluster
%   created.


scores = zeros(size(x,1),2);

for numchrom = 1:size(x,1)
  
   
   CC = decodenew(x(numchrom,:));
   temp=zeros(2,1);
   temp =computeGain(CC,Neighbor,numEdges, numberofVariables, numNegEdges);
   scores(numchrom,1)= -temp(1);
   scores(numchrom,2)= temp(2);
   
  
end

function score = computeGain(CC, Neighbor, numEdges, numberofVariables, numNegEdges)
         score=zeros(2,1);
        
         
         for nCC=1:size(CC,2)
                                             
            listnodes=CC{nCC};
             ls_pos=0;
             ds_pos=0;
             
             ls_neg=0;
             ds_neg=0;
             
             ls = 0;
       
             for j=1:size(listnodes,2)
               
                currnode=listnodes(1,j);
                
                %vicini correnti con segno
                neighborCN = Neighbor{currnode,1};
                signes = Neighbor{currnode,2};
                
                %creo il vettore che corrisponde a una riga della matrice
                %di adiacenza
                
                V = zeros(1,numberofVariables);
                
                V(neighborCN)=signes;
      
                ls = ls + sum(V(listnodes)); %ls totale
            
                ls_neg = ls_neg + sum(abs(V(listnodes)<0)); %ls negativo
                ls_pos = ls_pos + sum(V(listnodes)>0); %ls positivo
            
                ds_pos = ds_pos + sum(V > 0); %ds solo su archi pos
                ds_neg= ds_neg + sum(abs(V < 0)); %ds solo su archi neg              
                
                clear V;
                
%               
             end 
             cs_pos = ds_pos - ls_pos; % cs positivo
             
             if((numNegEdges>0) && (numEdges-numNegEdges)>0)
             
             gainCC = ls/numEdges + (ds_neg)^2/(numEdges*numNegEdges) - (ds_pos)^2/(numEdges*(numEdges-numNegEdges));  % signed modularity
             score(1)=score(1)+gainCC;
             end
            
             gainFitt = ls_neg + cs_pos;   % signed frustration
             score(2)=score(2) + gainFitt;
            

              
           
        end
end

end  
