%OK
function xoverKids  = crossover_cluster(parents,options,NVARS, ...
    FitnessFcn,thisScore,thisPopulation)

%
%   The arguments to the function are 
%     PARENTS: Parents chosen by the selection function
%     OPTIONS: Options structure created from GAOPTIMSET
%     NVARS: Number of variables 
%     FITNESSFCN: Fitness function 
%     STATE: State structure used by the GA solver 
%     THISSCORE: Vector of scores of the current population 
%     THISPOPULATION: Matrix of individuals in the current population



nKids = length(parents)/2;
xoverKids = zeros(nKids,NVARS); 
index = 1;

for i=1:nKids %scandisce sul numero dei figli
    
    % prende prima coppia genitori da parents
    r1 = thisPopulation(parents(index)); %prende primo genitore
    index = index + 1;
    r2 = thisPopulation(parents(index)); %prende secondo genitore
    index = index + 1;
    % Randomly select one gene from each parent
    length1=size(r1,2);

    child=zeros(1,length1);
    prob=rand(1,length1);
    indices=find(prob>0.5);
    indices1=find(prob<=0.5);
    child(indices) = r1(1,indices);
    child(indices1) = r2(1,indices1);
    xoverKids(i,:) = child; 
    clear child;

end


end