function mutationChildren = mutate_cluster(parents ,options,NVARS, ...
    FitnessFcn, state, thisScore,thisPopulation,mutationRate,Neighbor)

%   The arguments to the function are 
%     PARENTS: Parents chosen by the selection function
%     OPTIONS: Options structure created from GAOPTIMSET
%     NVARS: Number of variables 
%     FITNESSFCN: Fitness function 
%     STATE: State structure used by the GA solver 
%     THISSCORE: Vector of scores of the current population 
%     THISPOPULATION: Matrix of individuals in the current population
%     MUTATIONRATE: Rate of mutation

%   Copyright 2004 The MathWorks, Inc.
%   $Revision: 1.1.4.1 $  $Date: 2004/03/26 13:26:11 $

% 

mutationChildren = zeros(length(parents),NVARS);

for i=1:length(parents)
    if (mutationRate>rand)
   
        child = thisPopulation(parents(i),:);
        
        rand('twister',sum(100*clock))
        pos = ceil(NVARS*rand);
        valuepos=ceil(size(Neighbor{pos,1},2)*rand);

        child(pos) = Neighbor{pos,1}(valuepos);
        mutationChildren(i,:) = child; 
    else
        mutationChildren(i,:) = thisPopulation(parents(i),:);
    end
end


end
       